	TACHYON

	{ jm_servo8.fth - 8 servo driver with demo

	  UPDATED:	120907.1130 - BBR - scrapped menu in favor of useful words
	 						- stabilized driver background performance
	  CREATED:  120905.1800 - Brian Riley - Underhill Center, VT, USA
	  BASEDON:  100624.0000 - Jon "JonnyMac" McPhalen 

	  CODE CURRENT WITH KERNAL: 120905.0000
	}

	CLKFREQ #1_000_000 / CONSTANT cntsperusec
	cntsperusec #20,000 * CONSTANT cnts20msec

	#400  CONSTANT servomin			\ 0.4MS -  400 USECS
	#1500 CONSTANT servoctr			\ 1.5MS - 1500 USECS
	#2400 CONSTANT servomax			\ 2.4MS - 2400 USECS

	#8    CONSTANT MAXSERV			\ leave this number alone. 8 servos at possible
	 								\ 2.4 msecs each is 19.2 msecs and all that will
									\ fit in 20 msec frame

				\ user supplies the number of the first pin in series and total
				\ number of pins. the code assumes pins in sequence
	#4	  CONSTANT numserv			\ edit as needed
	#14	  CONSTANT startpin			\ edit as needed
																																				
	TABLE servo MAXSERV 4 * ALLOT	\ build servo table


	\ *******************************************************************
	{
		NOTES - SERVO8 will not run in foreground. It must be started in another cog either
		by manually typing in or included in a file to be copy/pasted (see below)
		
		- Once you save (BACKUP)the SERVO8 variables, constants, tables and words and shut the
		board down, you will need to manually restart the pulse driver by typing in
		                              ' SERVO8 >PFA 4 RUN
		
		- the "#10 PINSET" and its companion PINCLR operates as a debug using an LED from P10
		to ground so  SERVO8 can signal that it is up and running. Those two lines of code
		can be removed once the code is running to your liking.
	
	}
	\ *******************************************************************

	: SERVO8	( -- )					\ background servo pulse driver
										\ setup pins for output, then set to 0
		startpin numserv ADO I MASK OUTCLR LOOP

		#10 PINSET		\ **** DEBUG **** LIGHT LED
		
		BEGIN
			cnts20msec DELTA		\ sets up a new 20 ms frame with WAITCNT

			0 numserv ADO
				servo I 2* 2* + @	\ compute address and get pulse length
				servomin MAX		\ verify pulse is in range
				servomax MIN		\ 400 < pulse < 2400
				startpin I + MASK	\ calculate pin and set pinmask
				DUP					\ save copy of pinmask
				OUTSET				\ start pulse
				SWAP				\ bring pulse len forward
				#21 - us			\ 21 usec correction for pulse duration
				OUTCLR   			\ end pulse
			LOOP

			WAITCNT					\ done all servos	
		ATN? UNTIL
		#10 PINCLR		\ **** DEBUG **** TURN OFF LED
		;

\ *********** Useful Words/Commands **********************************

: SERVOFILL ( value -- ) servo numserv ROT LONGFILL ;

: SVCTR		( -- )	servoctr SERVOFILL ;
: SVMAX		( -- )	servomax SERVOFILL ;
: SVMIN		( -- )	servomin SERVOFILL ;

: SVZRO		( -- )	servo MAXSERV 0 LONGFILL ;

: D1		( -- )	servo $20 DUMP ;		\ dump servo tables

: S1		( pulseval -- ) servo ! ;		\ set individual servos
: S2		( pulseval -- ) servo 4 + ! ;
: S3		( pulseval -- ) servo 8 + ! ;
: S4		( pulseval -- ) servo #12 + ! ;



\ *******************************************************************

' SERVO8 >PFA 4 RUN		\ start SERVO8 in background COG 4
						\ 'tick' commands cannot be included in a word definition,
						\ it may be included in s copy/paste where it will be immediately
						\ acted upon, or manually typed

\ *******************************************************************

		
	END						

